<dx-tree-map
id="treemap"
[dataSource]="citiesPopulations"
title="The Most Populated Cities by Continents"
>
<dxo-tree-map-tooltip
[enabled]="true"
format="thousands"
[customizeTooltip]="customizeTooltip"
></dxo-tree-map-tooltip>
</dx-tree-map>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxTreeMapModule } from 'devextreme-angular';
import { CitiesPopulation, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxTreeMapModule,
],
})
export class AppComponent {
citiesPopulations: CitiesPopulation[];
constructor(service: Service) {
this.citiesPopulations = service.getCitiesPopulations();
}
customizeTooltip(arg) {
const data = arg.node.data;
let result = null;
if (arg.node.isLeaf()) {
result = `<span class='city'>${data.name}</span> (${
data.country})<br/>Population: ${arg.valueText}`;
}
return {
text: result,
};
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #treemap {
height: 500px;
}
::ng-deep .city {
font-weight: 500;
}
import { Injectable } from '@angular/core';
export interface CityPopulation {
value: number;
name: string;
country: string;
}
export interface CitiesPopulation {
name: string;
items: CityPopulation[];
}
const citiesPopulations: CitiesPopulation[] = [{
name: 'Africa',
items: [{
value: 21324000,
name: 'Lagos',
country: 'Nigeria',
}, {
value: 9735000,
name: 'Kinshasa',
country: 'Democratic Republic of the Congo',
}, {
value: 9278441,
name: 'Cairo',
country: 'Egypt',
}],
}, {
name: 'Asia',
items: [{
value: 24256800,
name: 'Shanghai',
country: 'China',
}, {
value: 23500000,
name: 'Karachi',
country: 'Pakistan',
}, {
value: 21516000,
name: 'Beijing',
country: 'China',
}, {
value: 16787941,
name: 'Delhi',
country: 'India',
}, {
value: 15200000,
name: 'Tianjin',
country: 'China',
}],
}, {
name: 'Australia',
items: [{
value: 4840600,
name: 'Sydney',
country: 'Austraila',
}, {
value: 4440000,
name: 'Melbourne',
country: 'Austraila',
}],
}, {
name: 'Europe',
items: [{
value: 14160467,
name: 'Istanbul',
country: 'Turkey',
}, {
value: 12197596,
name: 'Moscow',
country: 'Russia',
}, {
value: 8538689,
name: 'London',
country: 'United Kingdom',
}, {
value: 5191690,
name: 'Saint Petersburg',
country: 'Russia',
}, {
value: 4470800,
name: 'Ankara',
country: 'Turkey',
}, {
value: 3517424,
name: 'Berlin',
country: 'Germany',
}],
}, {
name: 'North America',
items: [{
value: 8874724,
name: 'Mexico City',
country: 'Mexico',
}, {
value: 8550405,
name: 'New York City',
country: 'United States',
}, {
value: 3884307,
name: 'Los Angeles',
country: 'United States',
}, {
value: 2808503,
name: 'Toronto',
country: 'Canada',
}],
}, {
name: 'South America',
items: [{
value: 11895893,
name: 'São Paulo',
country: 'Brazil',
}, {
value: 8693387,
name: 'Lima',
country: 'Peru',
}, {
value: 7776845,
name: 'Bogotá',
country: 'Colombia',
}, {
value: 6429923,
name: 'Rio de Janeiro',
country: 'Brazil',
}],
}];
@Injectable()
export class Service {
getCitiesPopulations() {
return citiesPopulations;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import TreeMap, { Tooltip } from 'devextreme-react/tree-map';
import type { ITooltipProps } from 'devextreme-react/tree-map';
import { citiesPopulation } from './data.ts';
const customizeTooltip: ITooltipProps['customizeTooltip'] = (arg) => {
const { data } = arg.node;
return {
text: arg.node.isLeaf()
? `<span class="city">${data.name}</span> (${data.country})<br/>Population: ${arg.valueText}`
: null,
};
};
function App() {
return (
<TreeMap
id="treemap"
dataSource={citiesPopulation}
title="The Most Populated Cities by Continents"
>
<Tooltip
enabled={true}
format="thousands"
customizeTooltip={customizeTooltip}
/>
</TreeMap>
);
}
export default App;
import React from 'react';
import TreeMap, { Tooltip } from 'devextreme-react/tree-map';
import { citiesPopulation } from './data.js';
const customizeTooltip = (arg) => {
const { data } = arg.node;
return {
text: arg.node.isLeaf()
? `<span class="city">${data.name}</span> (${data.country})<br/>Population: ${arg.valueText}`
: null,
};
};
function App() {
return (
<TreeMap
id="treemap"
dataSource={citiesPopulation}
title="The Most Populated Cities by Continents"
>
<Tooltip
enabled={true}
format="thousands"
customizeTooltip={customizeTooltip}
/>
</TreeMap>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const citiesPopulation = [{
name: 'Africa',
items: [{
value: 21324000,
name: 'Lagos',
country: 'Nigeria',
}, {
value: 9735000,
name: 'Kinshasa',
country: 'Democratic Republic of the Congo',
}, {
value: 9278441,
name: 'Cairo',
country: 'Egypt',
}],
}, {
name: 'Asia',
items: [{
value: 24256800,
name: 'Shanghai',
country: 'China',
}, {
value: 23500000,
name: 'Karachi',
country: 'Pakistan',
}, {
value: 21516000,
name: 'Beijing',
country: 'China',
}, {
value: 16787941,
name: 'Delhi',
country: 'India',
}, {
value: 15200000,
name: 'Tianjin',
country: 'China',
}],
}, {
name: 'Australia',
items: [{
value: 4840600,
name: 'Sydney',
country: 'Austraila',
}, {
value: 4440000,
name: 'Melbourne',
country: 'Austraila',
}],
}, {
name: 'Europe',
items: [{
value: 14160467,
name: 'Istanbul',
country: 'Turkey',
}, {
value: 12197596,
name: 'Moscow',
country: 'Russia',
}, {
value: 8538689,
name: 'London',
country: 'United Kingdom',
}, {
value: 5191690,
name: 'Saint Petersburg',
country: 'Russia',
}, {
value: 4470800,
name: 'Ankara',
country: 'Turkey',
}, {
value: 3517424,
name: 'Berlin',
country: 'Germany',
}],
}, {
name: 'North America',
items: [{
value: 8874724,
name: 'Mexico City',
country: 'Mexico',
}, {
value: 8550405,
name: 'New York City',
country: 'United States',
}, {
value: 3884307,
name: 'Los Angeles',
country: 'United States',
}, {
value: 2808503,
name: 'Toronto',
country: 'Canada',
}],
}, {
name: 'South America',
items: [{
value: 11895893,
name: 'São Paulo',
country: 'Brazil',
}, {
value: 8693387,
name: 'Lima',
country: 'Peru',
}, {
value: 7776845,
name: 'Bogotá',
country: 'Colombia',
}, {
value: 6429923,
name: 'Rio de Janeiro',
country: 'Brazil',
}],
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const citiesPopulation = [
{
name: 'Africa',
items: [
{
value: 21324000,
name: 'Lagos',
country: 'Nigeria',
},
{
value: 9735000,
name: 'Kinshasa',
country: 'Democratic Republic of the Congo',
},
{
value: 9278441,
name: 'Cairo',
country: 'Egypt',
},
],
},
{
name: 'Asia',
items: [
{
value: 24256800,
name: 'Shanghai',
country: 'China',
},
{
value: 23500000,
name: 'Karachi',
country: 'Pakistan',
},
{
value: 21516000,
name: 'Beijing',
country: 'China',
},
{
value: 16787941,
name: 'Delhi',
country: 'India',
},
{
value: 15200000,
name: 'Tianjin',
country: 'China',
},
],
},
{
name: 'Australia',
items: [
{
value: 4840600,
name: 'Sydney',
country: 'Austraila',
},
{
value: 4440000,
name: 'Melbourne',
country: 'Austraila',
},
],
},
{
name: 'Europe',
items: [
{
value: 14160467,
name: 'Istanbul',
country: 'Turkey',
},
{
value: 12197596,
name: 'Moscow',
country: 'Russia',
},
{
value: 8538689,
name: 'London',
country: 'United Kingdom',
},
{
value: 5191690,
name: 'Saint Petersburg',
country: 'Russia',
},
{
value: 4470800,
name: 'Ankara',
country: 'Turkey',
},
{
value: 3517424,
name: 'Berlin',
country: 'Germany',
},
],
},
{
name: 'North America',
items: [
{
value: 8874724,
name: 'Mexico City',
country: 'Mexico',
},
{
value: 8550405,
name: 'New York City',
country: 'United States',
},
{
value: 3884307,
name: 'Los Angeles',
country: 'United States',
},
{
value: 2808503,
name: 'Toronto',
country: 'Canada',
},
],
},
{
name: 'South America',
items: [
{
value: 11895893,
name: 'São Paulo',
country: 'Brazil',
},
{
value: 8693387,
name: 'Lima',
country: 'Peru',
},
{
value: 7776845,
name: 'Bogotá',
country: 'Colombia',
},
{
value: 6429923,
name: 'Rio de Janeiro',
country: 'Brazil',
},
],
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#treemap {
height: 500px;
}
.city {
font-weight: 500;
}

Your search did not match any results.

Vue Charts - Hierarchical Data Structure

The TreeMap component visualizes data as a set of rectangles (tiles). The tile size corresponds to a data point value relative to other data points.

The TreeMap component works with collections of objects. If objects in your collection have a plain structure, the component visualizes them as tiles. If your data is hierarchical, the TreeMap displays it as a group of nested tiles.

To bind data to the component, assign the collection of objects to the TreeMap's dataSource property.

www.wikipedia.org
Backend API
<template> <DxTreeMap id="treemap" :data-source="citiesPopulation" title="The Most Populated Cities by Continents" > <DxTooltip :enabled="true" :customize-tooltip="customizeTooltip" format="thousands" /> </DxTreeMap> </template> <script setup lang="ts"> import DxTreeMap, { DxTooltip } from 'devextreme-vue/tree-map'; import { citiesPopulation } from './data.ts'; const customizeTooltip = ({ node, node: { data: { name, country } }, valueText, }: Record<string, any>) => ( { text: node.isLeaf() ? `<span class="city">${name}</span> (${country})<br/>Population: ${valueText}` : null, }); </script> <style> #treemap { height: 500px; } .city { font-weight: 500; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
export const citiesPopulation = [{ name: 'Africa', items: [{ value: 21324000, name: 'Lagos', country: 'Nigeria', }, { value: 9735000, name: 'Kinshasa', country: 'Democratic Republic of the Congo', }, { value: 9278441, name: 'Cairo', country: 'Egypt', }], }, { name: 'Asia', items: [{ value: 24256800, name: 'Shanghai', country: 'China', }, { value: 23500000, name: 'Karachi', country: 'Pakistan', }, { value: 21516000, name: 'Beijing', country: 'China', }, { value: 16787941, name: 'Delhi', country: 'India', }, { value: 15200000, name: 'Tianjin', country: 'China', }], }, { name: 'Australia', items: [{ value: 4840600, name: 'Sydney', country: 'Austraila', }, { value: 4440000, name: 'Melbourne', country: 'Austraila', }], }, { name: 'Europe', items: [{ value: 14160467, name: 'Istanbul', country: 'Turkey', }, { value: 12197596, name: 'Moscow', country: 'Russia', }, { value: 8538689, name: 'London', country: 'United Kingdom', }, { value: 5191690, name: 'Saint Petersburg', country: 'Russia', }, { value: 4470800, name: 'Ankara', country: 'Turkey', }, { value: 3517424, name: 'Berlin', country: 'Germany', }], }, { name: 'North America', items: [{ value: 8874724, name: 'Mexico City', country: 'Mexico', }, { value: 8550405, name: 'New York City', country: 'United States', }, { value: 3884307, name: 'Los Angeles', country: 'United States', }, { value: 2808503, name: 'Toronto', country: 'Canada', }], }, { name: 'South America', items: [{ value: 11895893, name: 'São Paulo', country: 'Brazil', }, { value: 8693387, name: 'Lima', country: 'Peru', }, { value: 7776845, name: 'Bogotá', country: 'Colombia', }, { value: 6429923, name: 'Rio de Janeiro', country: 'Brazil', }], }];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

Once you assign the data source, specify the valueField and labelField properties. If you specify these properties, the component can determine the object fields that indicate TreeMap labels and values in the collection. The default values for these properties are value and name, respectively.

If your data is hierarchical, you also need to specify the childrenField property. The default childrenField property value is items. You can use these data field names to arrange your collection as shown in this demo.

For example, one of the objects in this demo data source looks as follows:

{
    name: 'Australia',
    items: [{
        value: 4840600,
        name: 'Sydney',
        country: 'Australia',
    }, {
        value: 4440000,
        name: 'Melbourne',
        country: 'Australia',
    }],
}

This object produces a tile with the Australia label. The Australia tile has two nested tiles labeled Sydney and Melbourne.

To make the TreeMap more informative, you can specify a title and implement a tooltip.